# Usage example:
#
#   nmake -f ../Core/Scripts/Core.mak \
#		COMPANY=DE_EPAGES CARTRIDGE=Core PERL=$(PERL) test
#

COMPANY = DE_EPAGES
CARTRIDGE = Core
PERL = perl
DE_EPAGES = ../../DE_EPAGES

RUNTEST	  = $(PERL) $(DE_EPAGES)/Installer/Scripts/runTests.pl
RUNBROWSER = $(PERL) $(DE_EPAGES)/Core/Scripts/browser.pl

CARTRIDGE_COVER_DB = $(EPAGES_STATIC)/coverage/$(COMPANY)-$(CARTRIDGE)/cover_db

COVER=$(PERL) $(EPAGES_PERL)/bin/cover

test:
	$(RUNTEST) -cartridge $(COMPANY)::$(CARTRIDGE) -storename $(STORE)

test_coverage:
	$(MAKE) collect_coverage STORE=$(STORE) COMPANY=$(COMPANY) CARTRIDGE=$(CARTRIDGE)
	$(MAKE) -i coverage_report COMPANY=$(COMPANY) CARTRIDGE=$(CARTRIDGE)

collect_coverage:
	$(MKDIR) $(CARTRIDGE_COVER_DB)
	$(COVER) $(CARTRIDGE_COVER_DB) -delete
	$(MAKE) -i test COMPANY=$(COMPANY) CARTRIDGE=$(CARTRIDGE) STORE=$(STORE) HARNESS_PERL_SWITCHES=-MDevel::Cover DEVEL_COVER_OPTIONS=+select,$(COMPANY)/$(CARTRIDGE)/,+ignore,.*,-coverage,statement,subroutine,-subs_only,1,-db,$(CARTRIDGE_COVER_DB)

coverage_report:
	$(COVER) $(CARTRIDGE_COVER_DB) $(COVER_ARGS)
	$(RUNBROWSER) $(CARTRIDGE_COVER_DB)/coverage.html
