(function($){
	var linkpicker,
		currentEditor,
		typeName = 'linkpicker';

	CKEDITOR.plugins.add( 'eplink',{
		init: function( editor ){

			// if the context menu plugin is loaded, register the menu items
			if(editor.addMenuItems){
				editor.addMenuItems({
					eplink: {
						label : editor.lang.link.menu,
						command : 'eplink',
						group : 'link',
						order : 1
					}
				});

				// remove not used link entries from context menue
				editor.removeMenuItem('link');
			}

			// if the "contextmenu" plugin is loaded, register the listeners.
			if(editor.contextMenu){
				editor.contextMenu.addListener(function(element, selection){
					if( !element || element.isReadOnly()){
						return null;
					}

					var anchor = CKEDITOR.plugins.link.tryRestoreFakeAnchor(editor, element);

					if (!anchor && !(anchor = CKEDITOR.plugins.link.getSelectedLink(editor))){
						return null;
					}

					var menu = {};

					if(anchor.getAttribute('href') && anchor.getChildCount()){
						menu = {eplink : CKEDITOR.TRISTATE_OFF};
					}

					return menu;
				});
			}

			editor.addCommand( 'eplink',{
				exec : function( ExecEditor ){
					currentEditor = ExecEditor;
					var selection = ExecEditor.getSelection(),
						selectedText = selection.getSelectedText();
						selectedLink = CKEDITOR.plugins.link.getSelectedLink(ExecEditor),
						selectedElem = selection.getSelectedElement(),
						imageSelected = undefined;

					if(selectedLink){
						var selectedLink = $(selectedLink.$),
							selectedUrl = selectedLink.attr('href');

						selectedText = selectedLink.text();

						if(selectedLink.children('img').length === 1){
							imageSelected = true;
						}

						// select link element
						ExecEditor.getSelection().selectElement( CKEDITOR.plugins.link.getSelectedLink(ExecEditor) );
					}
					else if(selectedElem && selectedElem.$.tagName.toLowerCase() === "img"){
						imageSelected = true;
					}

					var anchorData = currentEditor.getData(),
						anchorArray = [];

					if(anchorData){
						$(anchorData).find('a[name]').each(function(){
							anchorArray.push($(this).attr('name'));
						});
					}

					$.ready('de_epages.presentation.ui.linkpicker', function(){
						if(!linkpicker){
							// options for linkpicker
							var linkpickerOptions = {
									callback : function(url,title,newFlag){
										if(imageSelected){
											$(selectedElem.$).attr({alt: title, title: title});
										}
										var linkContent = '<a data-type="'+typeName+'" href="' + url + '"' + (newFlag ? ' target="_blank"' : '') +'>' + (imageSelected ? selectedElem.$.outerHTML : title) + '</a>';
										currentEditor.insertHtml(linkContent);
									}
								};

							// if linkpicker plugin is called from preview view (open dialog in top frame)
							if(currentEditor.isPreview){
								linkpicker = new top.de_epages('<div />').presentationUiLinkpicker(linkpickerOptions);
							}else{
								linkpicker = new de_epages('<div />').presentationUiLinkpicker(linkpickerOptions);
							}
						}

						linkpicker.presentationUiLinkpicker('open',{
							useAbsolute : currentEditor.config.useAbsolute ? true : false,
							title : selectedText,
							url : selectedUrl ? selectedUrl : '',
							anchors: anchorArray.length ? anchorArray : undefined
						});
					});
				}
			});

			editor.ui.addButton( 'eplink',{
				label: editor.lang.link.toolbar,
				command: 'eplink',
				className: 'cke_button_link'
			});

			editor.on( 'doubleclick', function( evt ){
				var selectedLink = $(CKEDITOR.plugins.link.getSelectedLink(editor));

				// if the link contains an image open only the image plugin
				if(!(selectedLink.children('img').length === 1)){
					return;
				}

				// if sender of double click event was a linkpicker link -> open necessary dialog
				if(jq(editor.getSelection().getStartElement().$).data('type') == typeName ){
					editor.execCommand('eplink');
					delete evt.data.dialog;
				}
			});

		}
	});
}(jQuery))